#include <Ethernet.h>
#include <SPI.h>
#include <aJSON.h>

byte mac[] = { 0x90, 0xA2, 0xDA, 0x0D, 0x7B, 0xEA };
IPAddress ip(192,168,1, 74);
EthernetServer server(80);

void setup()
{
 
  Serial.begin(9600);
  Serial.println("Entering program:");
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
}

void loop()
{
  // listen for incoming clients
  EthernetClient client = server.available();
  
  if (client) {
    aJsonObject* root;
    boolean readingJSON = false;
    Serial.println("\n\nNew client");
    String JSONstr;
    
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);  
        
        if(c == '{')   {
          // start receiving JSON string
          JSONstr = String(c);
          readingJSON = true;
        } else if (readingJSON)
         {
          JSONstr += c;
            if(c == '}') {
              readingJSON = false;          
              
              //We've received the id
              // send response
              client.println("HTTP/1.1 200 OK");
              client.println("Connnection: close");
              client.println();
              break;
            }
        }        
      }   
    }
    
    
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disconnected");
    
    // Convert String to char array for aJson parse
    char buf_len = JSONstr.length()+1;
    char* buffer;
    buffer = (char*) malloc(buf_len);
    JSONstr.toCharArray(buffer, buf_len);
    
    // Parse JSON string
    root = aJson.parse(buffer);
    if (root != NULL)  {
      Serial.println("Success!");
    }else{
      Serial.println("Failed to parse JSON");
    }

    
    // TODO: LOOK AT MEMORY LEAKS
    freeMem("Before aJson delete");
    free(buffer);
    aJson.deleteItem(root);
    freeMem("After aJson delete");
  }
}


//Code to print out the free memory

struct __freelist {
  size_t sz;
  struct __freelist *nx;
};

extern char * const __brkval;
extern struct __freelist *__flp;

uint16_t freeMem(uint16_t *biggest)
{
  char *brkval;
  char *cp;
  unsigned freeSpace;
  struct __freelist *fp1, *fp2;

  brkval = __brkval;
  if (brkval == 0) {
    brkval = __malloc_heap_start;
  }
  cp = __malloc_heap_end;
  if (cp == 0) {
    cp = ((char *)AVR_STACK_POINTER_REG) - __malloc_margin;
  }
  if (cp <= brkval) return 0;

  freeSpace = cp - brkval;

  for (*biggest = 0, fp1 = __flp, fp2 = 0; fp1; fp2 = fp1, fp1 = fp1->nx) {
      if (fp1->sz > *biggest) *biggest = fp1->sz;
    freeSpace += fp1->sz;
  }

  return freeSpace;
}

uint16_t biggest;

void freeMem(char* message) {
  Serial.print(message);
  Serial.print(":\t");
  Serial.println(freeMem(&biggest));
}
